/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */
#ifndef NMM_GRAPHURLOBJECT_HPP
#define NMM_GRAPHURLOBJECT_HPP NMM_GRAPHURLOBJECT_HPP

#include "nmm/nmm_prefix.hpp"

#include "GraphURL.hpp"

using namespace std;

namespace NMM {

  class GraphURLObject {
  protected:
    GraphURL* __url;
    string    __id;

    GraphURLObject(const string& id) : __url(0), __id(id) {};

  public:

    GraphURLObject() : __url(0), __id("unknown") {};

    virtual ~GraphURLObject() {};

    virtual void setGraphURL(const GraphURL* url) { __url = const_cast<GraphURL*>(url); };

    virtual const string& getID() const { return __id; };

    virtual Format* getFormatFromProtocol() const { return 0; };
    virtual Format* getFormatFromExtension() const;
    virtual Format* getFormatFromContent() const { return 0; };

    virtual string getNodeNameFromProtocol() const { return string(); };
    virtual string getNodeNameFromExtension() const { return string(); };
    virtual string getNodeNameFromContent() const { return string(); };

    virtual list<string> getInterfaces() const { list<string> l; return l; };
 
    virtual bool hasNMMRegistryLocationAndPort() { return true; }

    virtual void configureNodeDescription(NodeDescription &){}
  };

}
#include "nmm/nmm_suffix.hpp"

#endif //NMM_GRAPHURLOBJECT_HPP
